//try to do dropzone, open Programming/hw/project/src/components/DropZone and check code
//MyPlaylists && playerActions && AddTrack
import React, { useState, useEffect, useRef, useCallback } from "react";
import { useDropzone } from "react-dropzone";
import {
  addTrackToPlaylist,
  deleteTrackFromPlaylist,
} from "../actions/playerActions";
import { connect } from "react-redux";
import { Spin } from "antd";

import "../styles/library.css";

const AddTrack = ({
  myPlaylist,
  addTrackToPlaylist,
  deleteTrackFromPlaylist,
}) => {

  console.log("myPlaylist in AddTrack", myPlaylist)

  let ref = useRef();
  const [isLoading, setIsLoading] = useState(false);


  function Upload(playlistId, arrTracks, formData) {
    fetch("/track", {
      method: "POST",
      headers: localStorage.authToken
        ? { Authorization: "Bearer " + localStorage.authToken }
        : {},
      body: formData,
    })
      .then((res) => res.json()) //у чего есть then? у promise.
      .then(async (track) => {
        console.log("track: ", track);
        await addTrackToPlaylist(playlistId, arrTracks, track._id);
      });
    console.log("arrTracks in upload: ", arrTracks);
  }
  const onDrop = useCallback((acceptedFiles) => {
    setIsLoading(true);
    console.log(acceptedFiles)
    let arrTracks = [];
    myPlaylist.tracks && myPlaylist.tracks.map((item) => arrTracks.push({ ["_id"]: item._id }));
    acceptedFiles.map((file) => {
      let formData = new FormData();
      formData.append("track", file);
      Upload(localStorage.lastPLaylist, arrTracks, formData)
    });
    setIsLoading(false);

  })

  const { getRootProps, getInputProps } = useDropzone({ onDrop });

  return (
    <div className="my_tracks">
      <h2>My tracks in playlist {myPlaylist.name}</h2>
      <ul>
        {myPlaylist &&
          myPlaylist.tracks &&
          myPlaylist.tracks.map((track, index) => (
            <li key={index.toString()}>
              {track.originalFileName}
              <span
                className="adding-track"
                onClick={() => {
                  console.log(index);
                  deleteTrackFromPlaylist(
                    localStorage.lastPLaylist,
                    myPlaylist,
                    index
                  );
                }}
              >
                x
                  </span>
            </li>
          ))}
      </ul>
      <div className={"getRootProps main__description__dropzone"} {...getRootProps()}>
      {/* <div className={"main__description__dropzone"} {...getRootProps()}> */}
        <h2>Add track</h2>
        {/* <Spin className="" spinning={isLoading} /> */}
        <input {...getInputProps()}/>+
          </div>
      {/* </div> */}
    </div>
  );
};

const mapStateToProps = (state) => ({
  // newTrack: state.player.newTrack,
});

const mapDispatchtoProps = (dispatch) => ({
  addTrackToPlaylist: (idPlaylist, arrTracks, idTrack) =>
    dispatch(addTrackToPlaylist(idPlaylist, arrTracks, idTrack)),
  deleteTrackFromPlaylist: (idPlaylist, playlist, currentIndex) =>
    dispatch(deleteTrackFromPlaylist(idPlaylist, playlist, currentIndex)),
});

export default connect(mapStateToProps, mapDispatchtoProps)(AddTrack);
