import React, { useEffect, useState } from "react";
import {
  findMyPlaylists,
  findCurrentPlaylist,
  addTrackToPlaylist,
} from "../actions/playerActions";
// import AddTrack from "./AddTrack";
import { connect } from "react-redux";
import { Spin } from "antd";

const AddTrackFromLibToPlaylist = ({
  idTrack,
  setShowPlaylists,
  showPlaylists,
  findMyPlaylists,
  findCurrentPlaylist,
  addTrackToPlaylist,
  showMyPlaylists = [],
  playlist = [],
}) => {
  const [buttonClick, setButtonClick] = useState(false);
  // console.log(
  //   "showMyPlaylists in AddTrackFromLibToPlaylist: ",
  //   showMyPlaylists
  // );

  // useEffect(() => {
  //   findMyPlaylists();
  // }, [buttonClick]);

  useEffect(() => {
    findMyPlaylists();
  }, [showPlaylists]);

  function currentPlaylist(id) {
    findCurrentPlaylist(id);
  }

  let arrTracks = [];
  // let arrTracks;

  function upload(idPlaylist, arrTracks, idTrack) {
    addTrackToPlaylist(idPlaylist, arrTracks, idTrack);
    // AddTrack(localStorage.lastPLaylist, arrTracks, idTrack)
    console.log('arrTracks in upload: ', arrTracks);
  }

  function hide(){
    setTimeout(()=> setShowPlaylists(false), 5000)
  }

  return (
    <>
      <div className="my_playlists_list"
      //  style={{display: showPlaylists? 'flex' : 'none'}}
       >
        <h2>Chose playlist to add track in it</h2>
        <ul>
          {!showMyPlaylists.length ? (
            <div className="container">
              <Spin size="large" tip="loading..." />
            </div>
          ) : (
            showMyPlaylists.map((playlist, index) =>
              playlist.name ? (
                <li
                  key={index.toString()}
                  onClick={() => {
                    console.log("Selected playlist: ", playlist);
                    localStorage.lastPLaylist = playlist._id;
                    currentPlaylist(localStorage.lastPLaylist);
                    playlist.tracks &&
                    console.log('playlist.tracks: ', playlist.tracks) &&
                      playlist.tracks.map((item) =>
                        arrTracks.push({ ["_id"]: item._id })
                      );
                    upload(localStorage.lastPLaylist, arrTracks, idTrack);
                  }}
                >
                  {playlist.name}
                </li>
              ) : (
                ""
              )
            )
          )}
        </ul>
      </div>
      {hide()}
    </>
  );
};

const mapStateToProps = (state) => ({
  showMyPlaylists: state.player.showMyPlaylists,
  playlist: state.player.playlist,
});

const mapDispatchToProps = (dispatch) => ({
  findMyPlaylists: () => dispatch(findMyPlaylists()),
  findCurrentPlaylist: () =>
    dispatch(findCurrentPlaylist(`${localStorage.lastPLaylist}`)),
  addTrackToPlaylist: (idPlaylist, arrTracks, idTrack) =>
    dispatch(addTrackToPlaylist(idPlaylist, arrTracks, idTrack)),
});

export default connect(
  mapStateToProps,
  mapDispatchToProps
)(AddTrackFromLibToPlaylist);
