import React, { useEffect, useState } from "react";
import { connect } from "react-redux";
import { Spin } from "antd";
import Header from "./Header";
import Footer from "./Footer";

// import AddTrackFromLibToPlaylist from "./AddTrackFromLibToPlaylist";
import Player from "./Player";
import { getTracks, setCurrentTrack, findUser, currentTrackId } from "../actions/playerActions";

import "../styles/library.css";

const Lib = ({
  tracks,
  getTracks,
  login,
  setCurrentTrack,
  currentTrack,
  findUser,
  currentTrackId,
  trackId
}) => {
  // const [checkPlaylist, setCheckPlaylist] = useState(false);
  const [showPlaylists, setShowPlaylists] = useState(false);


  useEffect(() => {
    getTracks && getTracks() && findUser && findUser(login);
  }, []);

  const Track = ({ track, highlighted }) => {
    const { originalFileName, url, _id, trackIndex } = track;
    return (
      <li
        className={highlighted ? "highlighted" : null}
        onClick={(e) => {
          setCurrentTrack(trackIndex);
        }}
      >
        {/* <p> */}
          <span>{originalFileName}</span>
          <span
          className="adding-track"
            onClick={(e) => {
              console.log(_id)
              currentTrackId(_id);
              // e.target.closest("span");
              // e.target.closest("span") && e.target.closest("span").innerText == ' +'? console.log('e.target.closest("span"): ', e.target.closest("span"), e.target.closest("span").innerText) : '';
              // if(e.target.closest("span") && e.target.closest("span").innerText == ' +') {
                setShowPlaylists(true);
                // console.log('e.target.closest("span"): ', e.target.closest("span"), e.target.closest("span").innerText);
              // } else {
              //   setShowPlaylists(false);
              // }
              // e.target.closest("span") && 
              // e.target.closest("span").innerText == ' +'? setShowPlaylists(true) : setShowPlaylists(false);
              // e.target.span.innerText == " +"? setShowPlaylists(true) : setShowPlaylists(false);
            }}
          > +</span>
        {/* </p> */}
      </li>
    );
  };

  const TrackList = ({ playlist, currentTrack }) => {
    // console.log("playlist in library: ", playlist);
    return (
      <div className="main">
        <div className="trackList" 
        // onClick={() => setCheckPlaylist(false)}
        >
          <ul>
            {/* trackIndex это порядковый номер объекта в массиве */}
            {playlist.map((track, trackIndex) =>
              track.originalFileName && track.url && track._id !== null ? (
                <Track
                  key={trackIndex}
                  track={{ ...track, trackIndex }}
                  highlighted={trackIndex === currentTrack}
                />
              ) : (
                ""
              )
            )}
          </ul>
          {/* {showPlaylists?  <AddTrackFromLibToPlaylist idTrack={trackId} showPlaylists={showPlaylists} setShowPlaylists={setShowPlaylists}/> : null} */}
          {/* <AddTrackFromLibToPlaylist idTrack={trackId} 
          style={{display: showPlaylists? 'flex' : 'none'}}
          showPlaylists={showPlaylists}
          /> */}
          <Player playlist={tracks} />
        </div>
      </div>
    );
  };
  return (
    <div className="wrapper">
      <Header login={login} />
      {!tracks.length && (
        <div className="container">
          <Spin size="large" tip="loading..." />
        </div>
      )}
      <TrackList playlist={tracks} currentTrack={currentTrack} />
      <Footer />
    </div>
  );
};

const mapStateToProps = (state) => ({
  tracks: state.player.tracks,
  currentTrack: state.player.currentTrack,
  login: (state.auth.data.data && state.auth.data.data.sub.login) || "",
  trackId: state.player.trackId
});

const mapDispatchToProps = (dispatch) => ({
  getTracks: () => setTimeout(() => dispatch(getTracks()), 2000),
  setCurrentTrack: (trackIndex) => dispatch(setCurrentTrack(trackIndex)),
  findUser: (login) => dispatch(findUser(login)),
  currentTrackId: (_id) => dispatch(currentTrackId(_id)),
});

export default connect(mapStateToProps, mapDispatchToProps)(Lib);
